Installer - Bug #25481

Foreman fails to execute ansible commands when connected to ipa server
11/16/2018 12:50 PM - Marek Hulan

Status: Closed

Priority: Normal

Assignee: Ewoud Kohl van Wijngaarden
Category: Foreman modules

Target version:

Difficulty: Fixed in Releases: 1.22.1,1.23.0
Triaged: Yes Found in Releases:

Bugzilla link: 1650103 Red Hat JIRA:

Pull request: https://github.com/theforeman/puppet-for

eman_proxy/pull/485,
https://github.com/theforeman/puppet-for
eman_proxy/pull/511,
https://github.com/theforeman/puppet-for
eman_proxy/pull/534

Description
Cloned from https://bugzilla.redhat.com/show_bug.cgi?id=1650103

Description of problem:
Whne Satellite 6.4 is connected to an IPA server it fails to run Ansible commands on client systems

Version-Release number of selected component (if applicable):
- Satellite 6.4.0
- ansible-2.7.0-1.el7ae.noarch

How reproducible:
Everytime the Satellite is configured as an ipa client

Steps to Reproduce:

1. Install Satellite 6.4.0

2. Connect Satellite to IPA server

3. Try to run an Ansible command on a command on a client

Actual results:
The run fails with:
fatal: [fluffy.example.com]: UNREACHABLE! => {"changed": false, "msg": "Failed to connect to the host via ssh:

ssh_exchange_identification: Connection closed by remote host\r\n", "unreachable": true}

Expected results:
The run should work

Additional info:
The ipa client changes the file /etc/ssh/ssh_config when it is configured and adds the line

ProxyCommand /usr/bin/sss_ssh_knownhostsproxy -p %p %h
This was already reported for ovirt/RHV in this bugzillas:

- https://bugzilla.redhat.com/show_bug.cqi?id=1529851#c14
- https://bugzilla.redhat.com/show_bug.cgi?id=1531967#c5

Workaround:
Comment the line in /etc/ssh/ssh_config like this:

#ProxyCommand /usr/bin/sss_ssh_knownhostsproxy -p %p %h

and the Ansible jobs are working again.
Related issues:
Related to Installer - Bug #28559: Hardcoding Proxy Command breaks running An... Closed

Associated revisions

Revision 2e11f681 - 07/22/2019 04:30 PM - Ewoud Kohl van Wijngaarden
Fixes #25481 - Set ProxyCommand=none for Ansible (#511)
In case of IPA there's a ProxyCommand set that handles known hosts, but

foreman_ansible has its own way of handling known hosts. This sets the
ssh args to force override this.

History

#1 - 01/30/2019 01:21 PM - Tomer Brisker
- Project changed from Ansible to Installer

- Subject changed from Satellite fails to execute ansible commands when connected to ipa server
to Satellite fails to execute ansible commands when connected to ipa server

- Category set to Foreman modules

#2 - 01/30/2019 01:23 PM - Tomer Brisker
- Pull request https://github.com/theforeman/puppet-foreman_proxy/pull/485 added

#3 - 01/30/2019 01:23 PM - Tomer Brisker
- Status changed from New to Ready For Testing

#4 - 01/30/2019 01:58 PM - Ohad Levy

- Subject changed from Satellite fails to execute ansible commands when connected to ipa server to Foreman fails to execute ansible commands
when connected to ipa server

#5 - 06/06/2019 01:51 PM - The Foreman Bot
- Assignee set to Ewoud Kohl van Wijngaarden

- Pull request https://github.com/theforeman/puppet-foreman_proxy/pull/511 added

#6 - 07/22/2019 04:30 PM - The Foreman Bot
- Fixed in Releases 1.23.0 added

#7 - 07/22/2019 05:01 PM - Ewoud Kohl van Wijngaarden
- Status changed from Ready For Testing to Closed

Applied in changeset puppet-foreman_proxy|2e11{6810d8b4e7e8ce28f91bdf6a534c0f3e2f4.

#8 - 08/20/2019 12:47 PM - The Foreman Bot
- Pull request https://github.com/theforeman/puppet-foreman_proxy/pull/534 added

#9 - 08/20/2019 03:17 PM - Ewoud Kohl van Wijngaarden
- Triaged changed from No to Yes

- Fixed in Releases 1.22.1 added

#10 - 09/17/2019 06:24 PM - Marek Hulan

This causes a problem on my debian environment when ansible setup module is ran, for some reasons ‘ssh_args=" (even empty) changes the
behavior. Reproduced with ansible 2.8, when running under foreman-proxy user only (root seems to work fine), it seems like sftp/scp/pipe (dd over
ssh) does not work, therefore setup fails.

When | commented this line, it started working again but | had to also change owner of /var/lib/foreman-proxy/ansible/ to foreman-proxy on debian
(packaging issue?)

#11 - 09/17/2019 06:30 PM - Marek Hulan

If I specify also ansible defaults as per https:/docs.ansible.com/ansible/latest/reference_appendices/config.html#ansible-ssh-args (-C -0
ControlMaster=auto -o ControlPersist=60s) it works, so some of these options are probably necessary and by hardcoding ssh_args to
ProxyCommand=none we're breaking it
#12 - 10/31/2022 02:21 PM - Ewoud Kohl van Wijngaarden
- Related to Bug #28559: Hardcoding Proxy Command breaks running Ansible on Debian added
